' ================================================================================================
'  Theremino System - Rele Receiver
' ================================================================================================

Const NumRele as Int32 = 16					' Rele number			- Numero di RELE (8,16,24...)

Const SlotEnable as Int32 = 1				' Slot ENABLE			- Slot del filo ENABLE
Const SlotData as Int32 = 2					' Slot DATA				- Slot del filo DATA
Const SlotClock as Int32 = 3				' Slot CLOCK			- Slot del filo CLOCK




' ================================================================================================
'  - ENG - THE SIMPLIFIED MANAGEMENT ENDS HERE - MODIFY THE FOLLOWING CAREFULLY
' ------------------------------------------------------------------------------------------------
'  - ITA - LA GESTIONE SEMPLIFICATA FINISCE QUI - MODIFICARE LA PARTE SEGUENTE CON ATTENZIONE
' ================================================================================================

' ------------------------------------------------------------------------------------------------
'  Main loop
' ------------------------------------------------------------------------------------------------
Sub Main(ByVal s() As String)
	if Form1 IsNot Nothing then return
	Form1 = New form
	InitializeComponents
	MemoryMappedFile_Init
	timeBeginPeriod(1)
	StartThread
	While Form1.Visible
		Application.DoEvents
		Threading.Thread.Sleep(10)
	End While
End Sub

Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Form1.Closing
	timeEndPeriod(1)
	Timer1.Stop
	objThread.Abort
End Sub

Sub StartThread()
	' --------------------------------------------------------- asynchronously start the Thread 
	objThread = New Threading.Thread(AddressOf ExecuteThread)
	' --------------------------------------------------------- make the thread as background thread.
	objThread.IsBackground = True
	' --------------------------------------------------------- set the Priority of the thread.
	objThread.Priority = Threading.ThreadPriority.Highest
	' --------------------------------------------------------- start the thread.
	objThread.Start()
End Sub

Sub ExecuteThread
	Do
		MainThread
		Threading.Thread.Sleep(1)
	loop until false
End Sub

Sub PauseMS(Byval mS As Int32)
	Threading.Thread.Sleep(mS)
End Sub

Sub Timer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles Timer1.Tick
	TimedUpdate
End Sub

' ---------------------------------------------------------------------- User Interface Components
WithEvents Form1 As Form
WithEvents Timer1 As Timer = New Timer
Dim objThread As Threading.Thread
Dim Label1 As Label = new Label
Dim Label2 As Label = new Label

Sub InitializeComponents()
	Application.EnableVisualStyles
	form1.SuspendLayout
	' ------------------------------------------------------------------ Form
	Form1.Text = "Theremino Script - Rele Receiver V2"
	Form1.ClientSize = New System.Drawing.Size(460, 50)
	Form1.MinimumSize = Form1.Size
	Form1.StartPosition = FormStartPosition.CenterScreen
	' ------------------------------------------------------------------ Label 1
	Label1.BorderStyle = BorderStyle.Fixed3D
	Label1.BackColor = Color.White
	Label1.Location = New Point(10, 10)
	Label1.Font = New Font("Arial", 18)
	Label1.Size = New Size(form1.ClientSize.Width - 20, 30)
	Label1.Anchor = AnchorStyles.top or AnchorStyles.Left or AnchorStyles.right
	Form1.Controls.Add(Label1)
	' ------------------------------------------------------------------ Timer 1
	Timer1.Interval = 50
	Timer1.Start
	' ------------------------------------------------------------------ 
	Form1.ResumeLayout
	Form1.PerformLayout()
	Form1.show
End Sub

' ------------------------------------------------------------------------------------------------
' This function is executed more then 100 times per second by a separate Thread
' Funzione eseguita più di 100 volte al secondo in un thread separato 
' ------------------------------------------------------------------------------------------------
Dim ShiftData as string = StrDup(NumRele, "0")
Dim NewEnable as Single
Dim NewData as Single
Dim NewClock as Single
Dim OldClock as single

Sub MainThread()
	NewEnable = ReadSlot(SlotEnable)
	NewClock = ReadSlot(SlotClock)
	NewData = ReadSlot(SlotData)
	If NewClock <> OldClock then
		OldClock = NewClock
		If NewClock <> 0 then
			If NewData = 0 then
				ShiftData = Mid(ShiftData, 2) & "0"
			Else
				ShiftData = Mid(ShiftData, 2) & "1"
			End If
		End If
	End If
End Sub

' ------------------------------------------------------------------------------------------------
' This function is executed 20 times per second (no pauses here or the whole program is locked)
' Funzione eseguita 20 volte al sec. ( niente pause qui altrimenti tutto il programma si blocca)
' ------------------------------------------------------------------------------------------------
Sub TimedUpdate
	if NewEnable = 0 Then
		Label1.Text = ""
	Else
		Label1.Text = ShiftData
	End If
End Sub


' ===============================================================
'  WINDOWS SCHEDULER PRECISION
' =============================================================== 
<System.Runtime.InteropServices.DllImport("winmm.dll")> _
Private Function timeBeginPeriod(ByVal uPeriod As Int32) As Int32
End Function
<System.Runtime.InteropServices.DllImport("winmm.dll")> _
Private Function timeEndPeriod(ByVal uPeriod As Int32) As Int32
End Function
Friend Sub MillisecondPrecision_Start()
	timeBeginPeriod(1)
End Sub
Friend Sub MillisecondPrecision_End()
	timeEndPeriod(1)
End Sub

